# dsin(x)/dx
import math as m
import numpy as np
import matplotlib.pyplot as plt

def sin(x):
  return np.sin(x)

def df_dx_tp(f, x, h):    # three point formula
  return (f(x+h)-f(x-h))/(2*h)

if __name__=="__main__":
  x=np.linspace(0, 2*np.pi, 1000)
  dydx_t=np.zeros_like(x, float)
  h=1e-6
  
  i=0
  for xx in x:
    dydx_t[i]=df_dx_tp(sin, xx, h)
    i+=1
  
  plt.plot(x, dydx_b, 'r--')
  plt.show()
